"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UserFluxProvider = UserFluxProvider;
exports.useUserFlux = useUserFlux;
var _react = _interopRequireWildcard(require("react"));
var _index = _interopRequireDefault(require("./index"));
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var UserFluxContext = /*#__PURE__*/(0, _react.createContext)(null);
function UserFluxProvider(_ref) {
  var writeKey = _ref.writeKey,
    options = _ref.options,
    children = _ref.children;
  (0, _react.useEffect)(function () {
    _index["default"].initialize(writeKey, options);
    return function () {
      // Clean up if necessary
    };
  }, [writeKey, options]);
  var value = {
    identify: (0, _react.useCallback)(function (parameters) {
      return _index["default"].identify(parameters);
    }, []),
    track: (0, _react.useCallback)(function (parameters) {
      return _index["default"].track(parameters);
    }, []),
    trackBatch: (0, _react.useCallback)(function (events) {
      return _index["default"].trackBatch(events);
    }, []),
    reset: (0, _react.useCallback)(function () {
      return _index["default"].reset();
    }, []),
    updateDefaultTrackingProperties: (0, _react.useCallback)(function (properties) {
      _index["default"].updateDefaultTrackingProperties(properties);
    }, []),
    getUserId: (0, _react.useCallback)(function () {
      return _index["default"].getUserId();
    }, []),
    getAnonymousId: (0, _react.useCallback)(function () {
      return _index["default"].getAnonymousId();
    }, []),
    flush: (0, _react.useCallback)(function () {
      return _index["default"].flush();
    }, []),
    trackPageView: (0, _react.useCallback)(function () {
      return _index["default"].trackPageView();
    }, [])
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(UserFluxContext.Provider, {
    value: value,
    children: children
  });
}
function useUserFlux() {
  var context = (0, _react.useContext)(UserFluxContext);
  if (context === null) {
    throw new Error("useUserFlux must be used within a UserFluxProvider");
  }
  return context;
}